=== debian/changelog ===
rocksdb (6.11.4-3) unstable; urgency=medium

  * Explicitly link shared library with dynamic linking library
    (closes: #976838).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 10 Dec 2020 18:13:16 +0100

rocksdb (6.11.4-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 07 Dec 2020 22:17:04 +0100

rocksdb (6.11.4-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb6.10 to librocksdb6.11 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 30 Jul 2020 20:07:53 +0200

rocksdb (6.10.2-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb6.7 to librocksdb6.10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 25 Jun 2020 20:47:15 +0200

rocksdb (6.7.3-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb6.6 to librocksdb6.7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 19 Apr 2020 19:19:07 +0000

rocksdb (6.6.4-2) experimental; urgency=medium

  * Really fix db_test for i386 and mipsel for this release.

  [ Michael R. Crusoe <michael.crusoe@gmail.com> ]
  * Build on riscv64 (closes: #952681).
  * Build in parallel.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 27 Feb 2020 17:26:07 +0000

rocksdb (6.6.4-1) experimental; urgency=medium

  * New upstream release.
  * Update patches.
  * Library transition from librocksdb6.5 to librocksdb6.6 .
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 18 Feb 2020 18:34:59 +0000

rocksdb (6.5.3-1) experimental; urgency=medium

  * New upstream release.
  * Enable building on armel and armhf.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 14 Jan 2020 19:39:26 +0000

rocksdb (6.5.2-2) experimental; urgency=medium

  * Fix db_test for i386 and mipsel.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 28 Dec 2019 22:54:16 +0000

rocksdb (6.5.2-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb6.2 to librocksdb6.5 .
  * Update Standards-Version to 4.4.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 15 Dec 2019 20:49:55 +0000

rocksdb (6.2.4-2) experimental; urgency=medium

  * Fix ARM64 FTBFS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 25 Sep 2019 19:16:57 +0000

rocksdb (6.2.4-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 24 Sep 2019 15:43:08 +0000

rocksdb (6.2.2-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb6.1 to librocksdb6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Aug 2019 14:28:39 +0000

rocksdb (6.1.2-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb5.17 to librocksdb6.1 .
  * Fix FTBFS with GCC 9 (closes: #925818).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 14 Jul 2019 05:31:06 +0000
