=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifneq ($(filter $(DEB_HOST_ARCH),armel mips mipsel riscv64),)
	export PLATFORM_LDFLAGS=-latomic
endif

ifeq ($(DEB_HOST_ARCH),armel)
	export DEB_CFLAGS_MAINT_APPEND= -mfloat-abi=softfp
	export DEB_CXXFLAGS_MAINT_APPEND= -mfloat-abi=softfp
endif

override_dh_auto_build:
	PORTABLE=1 dh_auto_build -- all
	PORTABLE=1 dh_auto_build -- shared_lib

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp/usr/

override_dh_missing:
	dh_missing --list-missing

%:
	dh $@

.PHONY: override_dh_auto_build override_dh_auto_test \
	override_dh_auto_install override_dh_missing
